import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';

var _class, _class2, _temp2;

// eslint-disable-next-line no-unused-vars
import React, { Component } from 'react';
import { shape, func, bool } from 'prop-types';
import { fromPromise } from 'mobx-utils';
import { observer } from 'mobx-react';

var FetchAll = observer(_class = (_temp2 = _class2 = function (_Component) {
  _inherits(FetchAll, _Component);

  function FetchAll() {
    var _temp, _this, _ret;

    _classCallCheck(this, FetchAll);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.onSuccess = function (data) {
      return _this.props.whenFulfilled({
        data: data,
        isReloading: _this.props.store.isListLoading
      });
    }, _this.onError = function (error) {
      return _this.props.whenRejected(error);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  FetchAll.prototype.componentWillMount = function componentWillMount() {
    this.fromPromise = fromPromise(this.props.store.fetchAll());
  };

  FetchAll.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (!nextProps.onlyOnInit) {
      this.fromPromise = fromPromise(this.props.store.fetchAll());
    }
  };

  FetchAll.prototype.render = function render() {
    if (this.props.store.isEmpty.get()) {
      return this.fromPromise.case({
        pending: this.props.whenLoading,
        fulfilled: this.onSuccess,
        rejected: this.onError
      });
    }

    return this.props.whenFulfilled({
      data: this.props.store.asArray,
      isReloading: this.props.store.isListLoading
    });
  };

  return FetchAll;
}(Component), _class2.defaultProps = {
  whenLoading: function whenLoading() {
    return null;
  },
  whenRejected: function whenRejected() {
    return null;
  },
  whenFulfilled: function whenFulfilled() {
    return React.createElement(
      'div',
      null,
      'No template for whenFullfilled'
    );
  },
  onlyOnInit: false
}, _temp2)) || _class;

export { FetchAll as default };
process.env.NODE_ENV !== "production" ? FetchAll.propTypes = {
  store: shape({
    fetchAll: func
  }).isRequired,
  // eslint-disable-next-line
  onlyOnInit: bool,
  whenLoading: func,
  whenRejected: func,
  whenFulfilled: func.isRequired
} : void 0;