import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';

var _class, _class2, _temp2;

// eslint-disable-next-line no-unused-vars
import React, { Component } from 'react';
import { shape, func, oneOfType, string, number } from 'prop-types';
import { fromPromise } from 'mobx-utils';
import { observer } from 'mobx-react';

var FetchOne = observer(_class = (_temp2 = _class2 = function (_Component) {
  _inherits(FetchOne, _Component);

  function FetchOne() {
    var _temp, _this, _ret;

    _classCallCheck(this, FetchOne);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.onSuccess = function (data) {
      return _this.props.whenFulfilled({ data: data, isReloading: data.isReloading });
    }, _this.onError = function (error) {
      return _this.props.whenRejected(error);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  FetchOne.prototype.componentWillMount = function componentWillMount() {
    this.fromPromise = fromPromise(this.props.store.fetchOne(this.props.id));
  };

  FetchOne.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    this.fromPromise = fromPromise(this.props.store.fetchOne(nextProps.id));
  };

  FetchOne.prototype.render = function render() {
    if (this.props.store.has(this.props.id)) {
      var model = this.props.store.getOne(this.props.id);
      return this.props.whenFulfilled({ data: model, isReloading: model.isReloading });
    }

    return this.fromPromise.case({
      pending: this.props.whenLoading,
      fulfilled: this.onSuccess,
      rejected: this.onError
    });
  };

  return FetchOne;
}(Component), _class2.defaultProps = {
  whenLoading: function whenLoading() {
    return null;
  },
  whenRejected: function whenRejected() {
    return null;
  },
  whenFulfilled: function whenFulfilled() {
    return React.createElement(
      'div',
      null,
      'No template for whenFullfilled'
    );
  }
}, _temp2)) || _class;

export { FetchOne as default };
process.env.NODE_ENV !== "production" ? FetchOne.propTypes = {
  store: shape({
    fetchOne: func
  }).isRequired,
  id: oneOfType([string, number]).isRequired,
  whenLoading: func,
  whenRejected: func,
  whenFulfilled: func.isRequired
} : void 0;