import _classCallCheck from "babel-runtime/helpers/classCallCheck";

var ServiceAdapter = function () {
  function ServiceAdapter(service) {
    _classCallCheck(this, ServiceAdapter);

    this.service = service;
  }

  ServiceAdapter.prototype.fetchAll = function fetchAll() {
    var _service;

    return (_service = this.service).fetchAll.apply(_service, arguments);
  };

  ServiceAdapter.prototype.fetchOne = function fetchOne() {
    var _service2;

    return (_service2 = this.service).fetchOne.apply(_service2, arguments);
  };

  ServiceAdapter.prototype.createItem = function createItem() {
    var _service3;

    return (_service3 = this.service).createItem.apply(_service3, arguments);
  };

  ServiceAdapter.prototype.updateItem = function updateItem() {
    var _service4;

    return (_service4 = this.service).updateItem.apply(_service4, arguments);
  };

  ServiceAdapter.prototype.deleteItem = function deleteItem() {
    var _service5;

    return (_service5 = this.service).deleteItem.apply(_service5, arguments);
  };

  return ServiceAdapter;
}();

export { ServiceAdapter as default };