import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import { observable } from 'mobx';
import { createViewModel } from 'mobx-utils';
import { serialize as doSerialize } from 'serializr';

var DomainModel = function () {
  function DomainModel() {
    _classCallCheck(this, DomainModel);

    this.isReloading = observable.box(false);
    this.isError = observable.box(false);
    this.isSaving = observable.box(false);
    this.isSaved = observable.box(false);
    this.isUpdating = observable.box(false);
    this.isDeleting = observable.box(false);
    this.isDeleted = observable.box(false);
  }

  DomainModel.prototype.serialize = function serialize() {
    return doSerialize(this);
  };

  _createClass(DomainModel, [{
    key: 'viewModel',
    get: function get() {
      if (!this.reusedViewModel) {
        this.reusedViewModel = createViewModel(this);
        return this.reusedViewModel;
      }

      return this.reusedViewModel;
    }
  }]);

  return DomainModel;
}();

export { DomainModel as default };