'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _mobx = require('mobx');

var _mobxUtils = require('mobx-utils');

var _serializr = require('serializr');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DomainModel = function () {
  function DomainModel() {
    (0, _classCallCheck3.default)(this, DomainModel);
    this.isReloading = _mobx.observable.box(false);
    this.isError = _mobx.observable.box(false);
    this.isSaving = _mobx.observable.box(false);
    this.isSaved = _mobx.observable.box(false);
    this.isUpdating = _mobx.observable.box(false);
    this.isDeleting = _mobx.observable.box(false);
    this.isDeleted = _mobx.observable.box(false);
  }

  DomainModel.prototype.serialize = function serialize() {
    return (0, _serializr.serialize)(this);
  };

  (0, _createClass3.default)(DomainModel, [{
    key: 'viewModel',
    get: function get() {
      if (!this.reusedViewModel) {
        this.reusedViewModel = (0, _mobxUtils.createViewModel)(this);
        return this.reusedViewModel;
      }

      return this.reusedViewModel;
    }
  }]);
  return DomainModel;
}();

exports.default = DomainModel;
module.exports = exports['default'];