'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _class2, _temp2; // eslint-disable-next-line no-unused-vars


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _mobxUtils = require('mobx-utils');

var _mobxReact = require('mobx-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FetchAll = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(FetchAll, _Component);

  function FetchAll() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, FetchAll);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.onSuccess = function (data) {
      return _this.props.whenFulfilled({
        data: data,
        isReloading: _this.props.store.isListLoading
      });
    }, _this.onError = function (error) {
      return _this.props.whenRejected(error);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  FetchAll.prototype.componentWillMount = function componentWillMount() {
    this.fromPromise = (0, _mobxUtils.fromPromise)(this.props.store.fetchAll());
  };

  FetchAll.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (!nextProps.onlyOnInit) {
      this.fromPromise = (0, _mobxUtils.fromPromise)(this.props.store.fetchAll());
    }
  };

  FetchAll.prototype.render = function render() {
    if (this.props.store.isEmpty.get()) {
      return this.fromPromise.case({
        pending: this.props.whenLoading,
        fulfilled: this.onSuccess,
        rejected: this.onError
      });
    }

    return this.props.whenFulfilled({
      data: this.props.store.asArray,
      isReloading: this.props.store.isListLoading
    });
  };

  return FetchAll;
}(_react.Component), _class2.defaultProps = {
  whenLoading: function whenLoading() {
    return null;
  },
  whenRejected: function whenRejected() {
    return null;
  },
  whenFulfilled: function whenFulfilled() {
    return _react2.default.createElement(
      'div',
      null,
      'No template for whenFullfilled'
    );
  },
  onlyOnInit: false
}, _temp2)) || _class;

exports.default = FetchAll;
process.env.NODE_ENV !== "production" ? FetchAll.propTypes = {
  store: (0, _propTypes.shape)({
    fetchAll: _propTypes.func
  }).isRequired,
  // eslint-disable-next-line
  onlyOnInit: _propTypes.bool,
  whenLoading: _propTypes.func,
  whenRejected: _propTypes.func,
  whenFulfilled: _propTypes.func.isRequired
} : void 0;
module.exports = exports['default'];