'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _class2, _temp2; // eslint-disable-next-line no-unused-vars


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _mobxUtils = require('mobx-utils');

var _mobxReact = require('mobx-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FetchOne = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(FetchOne, _Component);

  function FetchOne() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, FetchOne);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.onSuccess = function (data) {
      return _this.props.whenFulfilled({ data: data, isReloading: data.isReloading });
    }, _this.onError = function (error) {
      return _this.props.whenRejected(error);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  FetchOne.prototype.componentWillMount = function componentWillMount() {
    this.fromPromise = (0, _mobxUtils.fromPromise)(this.props.store.fetchOne(this.props.id));
  };

  FetchOne.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    this.fromPromise = (0, _mobxUtils.fromPromise)(this.props.store.fetchOne(nextProps.id));
  };

  FetchOne.prototype.render = function render() {
    if (this.props.store.has(this.props.id)) {
      var model = this.props.store.getOne(this.props.id);
      return this.props.whenFulfilled({ data: model, isReloading: model.isReloading });
    }

    return this.fromPromise.case({
      pending: this.props.whenLoading,
      fulfilled: this.onSuccess,
      rejected: this.onError
    });
  };

  return FetchOne;
}(_react.Component), _class2.defaultProps = {
  whenLoading: function whenLoading() {
    return null;
  },
  whenRejected: function whenRejected() {
    return null;
  },
  whenFulfilled: function whenFulfilled() {
    return _react2.default.createElement(
      'div',
      null,
      'No template for whenFullfilled'
    );
  }
}, _temp2)) || _class;

exports.default = FetchOne;
process.env.NODE_ENV !== "production" ? FetchOne.propTypes = {
  store: (0, _propTypes.shape)({
    fetchOne: _propTypes.func
  }).isRequired,
  id: (0, _propTypes.oneOfType)([_propTypes.string, _propTypes.number]).isRequired,
  whenLoading: _propTypes.func,
  whenRejected: _propTypes.func,
  whenFulfilled: _propTypes.func.isRequired
} : void 0;
module.exports = exports['default'];